<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="保养部位ID" prop="maintStationId">
              <el-input v-model="queryParams.maintStationId" placeholder="请输入保养部位ID" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="保养项目ID" prop="maintProjectId">
              <el-input v-model="queryParams.maintProjectId" placeholder="请输入保养项目ID" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['dms:dmsBaseStationProject:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['dms:dmsBaseStationProject:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['dms:dmsBaseStationProject:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['dms:dmsBaseStationProject:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" :columns="columns" :search="true" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="dmsBaseStationProjectList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="保养部位ID" align="center" prop="maintStationId" v-if="columns[0].visible"/>
        <el-table-column label="保养项目ID" align="center" prop="maintProjectId" v-if="columns[1].visible"/>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['dms:dmsBaseStationProject:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['dms:dmsBaseStationProject:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改保养部位关联项目信息对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="dmsBaseStationProjectFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="保养部位ID" prop="maintStationId">
          <el-input v-model="form.maintStationId" placeholder="请输入保养部位ID" />
        </el-form-item>
        <el-form-item label="保养项目ID" prop="maintProjectId">
          <el-input v-model="form.maintProjectId" placeholder="请输入保养项目ID" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="DmsBaseStationProject" lang="ts">
import { listDmsBaseStationProject, getDmsBaseStationProject, delDmsBaseStationProject, addDmsBaseStationProject, updateDmsBaseStationProject } from '@/api/dms/dmsBaseStationProject';
import { DmsBaseStationProjectVO, DmsBaseStationProjectQuery, DmsBaseStationProjectForm } from '@/api/dms/dmsBaseStationProject/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const dmsBaseStationProjectList = ref<DmsBaseStationProjectVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const dmsBaseStationProjectFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

// 列显隐信息
const columns = ref<FieldOption[]>([
        { key: 0, label: `保养部位ID`, visible: true },
        { key: 1, label: `保养项目ID`, visible: true },
]);

const initFormData: DmsBaseStationProjectForm = {
  maintStationId: undefined,
  maintProjectId: undefined
}
const data = reactive<PageData<DmsBaseStationProjectForm, DmsBaseStationProjectQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    maintStationId: undefined,
    maintProjectId: undefined,
    params: {
    }
  },
  rules: {
    maintStationId: [
      { required: true, message: "保养部位ID不能为空", trigger: "blur" }
    ],
    maintProjectId: [
      { required: true, message: "保养项目ID不能为空", trigger: "blur" }
    ]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询保养部位关联项目信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listDmsBaseStationProject(queryParams.value);
  dmsBaseStationProjectList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  dmsBaseStationProjectFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: DmsBaseStationProjectVO[]) => {
  ids.value = selection.map(item => item.maintStationId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加保养部位关联项目信息";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: DmsBaseStationProjectVO) => {
  reset();
  const _maintStationId = row?.maintStationId || ids.value[0]
  const res = await getDmsBaseStationProject(_maintStationId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改保养部位关联项目信息";
}

/** 提交按钮 */
const submitForm = () => {
  dmsBaseStationProjectFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.maintStationId) {
        await updateDmsBaseStationProject(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addDmsBaseStationProject(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: DmsBaseStationProjectVO) => {
  const _maintStationIds = row?.maintStationId || ids.value;
  await proxy?.$modal.confirm('是否确认删除保养部位关联项目信息编号为"' + _maintStationIds + '"的数据项？').finally(() => loading.value = false);
  await delDmsBaseStationProject(_maintStationIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('dms/dmsBaseStationProject/export', {
    ...queryParams.value
  }, `dmsBaseStationProject_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
